#!/usr/bin/perl

use strict;

my %features =
(
	'703',	'Insert, Home, Page Down keys map to Show_Button',
	'5149',	'Support for Infinite Lines',
#	'5193',	'HOOPS Shutting Down on Out of Memory',
	'5938',	'Camera Near Limit Enhancement',
#	'6013',	'32-bit Software Z-Buffer',
#	'6093',	'Render To Shadow Map',
	'6122',	'Dot Mode For Max Extent Culling',
#	'6123',	'Polyline Performance Enhancement with Wide Lines',
	'6139',	'Window Border Enhancement',
	'6200',	'Database Activity Callbacks in HOOPS I.M.',
	'6223',	'Shader-Based DX9 Driver',
	'6231',	'Draw Time Usage of a Shadow Attribute Tree',
	'6232',	'Segment-Level Culling Vector',
	'6240',	'Improvements To Boolean Support',
	'6269',	'Shadow Maps',
	'6276',	'CGM3 Driver Enhancements',
	'6306',	'Support For A Skybox',
	'6313',	'Enhancements to Set_Window_Pattern',
	'6347',	'Update Interrupt Enhancements',
	'6348',	'Deferred Drawing Of Pixel Threshold on Culled Segments',
	'6353',	'Improve Ellipse Drawing',
	'6380',	'Full Screen Mode for Stand Alone Applications',
	'6415',	'Option to Avoid View Refresh in HLR Mode',
	'6431',	'New Interface to Show Shell Face Count',
	'6437',	'Rollback_Ink Function',
	'6471',	'Support Include Of Geometry',
	'6473',	'Stereo Distance Rendering Option',
	'6478',	'Set Callback With Data',
	'6495',	'Segment Level Display Lists',
	'6592',	'Definition Of A Segment-level Selection Point',
	'6600',	'Cross-Platform OpenGL Image Generation',
	'6711',	'Tristrips Generation Enhancement',
	'6743',	'Reflection Plane Support',
#	'6819',	'LOD Generator Correctly Identifying Planars',
	'6894',	'Text Index Setting via IM',
	'6896',	'Disjoint Polyline API',
	'6924',	'HC_Compute_Shell_Sweep API',
	'6982',	'API To Remove Legacy Text Extent Fudge',
	'7005',	'HC_Show_Image_Name API',
	'7014',	'HC_Show_Shell_Tristrip_Count API',
	'7185',	'Further Simple Reflection Optimizations',
	'7186',	'Shadow Map Stabilization',
	'7314',	'Rasters Supported in Show_Geometry_Pointer',
	'7349',	'Enhancements to Printf Driver',
	'7835',	'Promotion of Incremental Updates to Full Updates',
);

my %details =
(
	'703',	'These keys are now mapped in 3dGS. To enable these buttons, use the "misc" group name in a call to ::Enable_Button_Events.',

	'5149',	'Hoops/3dGS now contains support for a new infinite line primitive. See the documentation for ::Insert_Infinite_Line for more details.',

#	'5193',	'',

	'5938',	'::Show_Camera_Near_Limit now returns a Boolean value. The return value is true if the near limit is explicitly set on the camera, false if it is just using the global value controlled by the \ref Define_System_Options_camera_near_limit "camera near limit" system option.',

#	'6013',	'',

#	'6093',	'',

	'6122',	'A new legal value has been added to the \ref Set_Heuristics_culling "Set_Heuristics \'culling\'"  option. Users may now specify "maximum extent mode" to define the drawing behavior when a segment\'s bounding box goes below the "maximum extent".',


#	'6123',	'',

	'6139',	'::Set_Window_Frame has been enhanced with two new options -- "decorative" and "inset" -- that allow the user to better control the window border with respect to the owning window and to other windows in the scene that also have visible borders.',

	'6200',	'The HOOPS Intermediate Mode (I.M.) interface contains new callbacks to allow the user to detect when generalized changes have occurred in the database.  The new callback point -- "segment activity change" -- will be activated when there is a modification to the segment tree under the point where the callback is set.',

	'6223',	'We continue to make enhancements to our new DX9 driver. This release includes support for procedural shaders, among others.',

	'6231',	'A new heuristic -- \ref Set_Heuristics_static_model "static model" -- allows HOOPS to create a compiled "draw tree" for the scene which should result in better rendering performance.',

	'6232',	'Segment-level culling allows HOOPS to avoid drawing all of the objects in a particular segment if the segment\'s camera angle meets certain criteria. See the \ref Set_Heuristics_vector "Set_Heuristics \'vector\'" and \ref Set_Heuristics_culling "Set_Heuristics \'vector tolerance\'" options for more details.',

	'6240',	'Enhancements to the internal normal-generation code have corrected some visual problems, specifically with respect to Boolean operations.  The new normal generation code has a hard coded cutoff angle by which it will create a hard edge. This causes edge visibility (and shading) to be correct after a boolean subtraction of two spheres, for instance.',

	'6269',	'This release contains support for generating \ref Set_Rendering_Options_shadow_map "shadow maps", and enhanced control for the \ref Set_Visibility_shadows "visibity of different types of shadows". Click on these links for more info.',

	'6276',	'The CGM3 Driver now contains support for font tables. See the <a href="PlatformDeviceGuide_C.html#cgm3">Platform and Device Guide</a> for details.',

	'6306',	'Users can define a "sky-box" texture that can then be used to apply a "sky-map" to the scene. See the enhancements to the \ref Define_Texture_source "\em source option for Define_Texture" for details.',

	'6313',	'A new option -- "invisible" -- for ::Set_Window_Pattern creates a window pattern that is clear with the added behavior that it does not clear the z-buffer prior to drawing the geometry within the window. This allows geometry within the subwindow to interact with geometry contained in the parent window.',

	'6347',	'Users can now abort an update by setting the \ref Set_Driver_Options_exit_update "exit update" driver option. This causes HOOPS to call a previously defined I.M. callback function at regular intervals during an update. In turn, all of the update functions including ::Update_Display and ::Update_Display_Timed and their variants now return a Boolean value indicating whether or not HOOPS completed drawing the scene in the last update.  Note that ::Update_Display_Timed returns FALSE if the update did not complete within the specified time, and it may also return FALSE if the "exit update" callback interrupted the update. To determine the nature of a FALSE return value from ::Update_Display_Timed or one of its variants, users can pass the \ref Show_Device_Info_event_interrupted "event interrupted" option to ::Show_Device_Info.',

	'6348',	'Users can now defer drawing of a segment if that segment\'s bounding box goes above the "maximum extent" value. See the \ref Set_Heuristic_culling "defer" suboption for the "cullling" heuristic for more details.',

	'6353',	'Circular and elliptical shapes now use Bresenham\'s algorithm for drawing.  This leads to rapidly drawn shapes that tend to be rounder than they were previously.',

	'6380',	'Applications that use HOOPS in stand alone mode (no GUI toolkit) can set hardware accelerated display drivers to use \ref Set_Driver_Options_fullscreen "fullscreen" mode, a new option for ::Set_Driver_Options.',

	'6415',	'A new update control -- \ref Control_Update_set_hidden_line_regeneration "set hidden line regeneration" -- forces 3dGS to ignore its internal update flags and either completely regenerate or leave the hidden line geometry as it currently is. This option only applies when the hsra is set to "hidden line".',

	'6431',	'A new function gives the user the number of faces in a particular shell. See ::Show_Shell_Face_Count for details.',

	'6437',	'::Rollback_Ink gives the user a way to easily delete points in a polyline that is being created dynamically using the ::Insert_Ink function. See the documentaion for details.',

	'6471',	'Users can now ask HOOPS to reference some data while the segment tree is being processed for rendering, without making a copy of the data. This is accomplished using the new function ::Reference_Geometry or its condtional variant ::Conditional_Reference. This allows geometry to be included from a segment without attributes or subsegments, and without additonal include segment traversal.',

	'6473',	'Users can control the distance between camera position and the stereo focal plane. See the new \ref Set_Rendering_Options_stereo_distance "stereo distance" option for details.',

	'6478',	'It is now possible to associate data with an I.M. callback, so that when a callback is triggered, the pointer to that data is passed to the callback function. See the documentation for ::Set_Callback_With_Data and ::Show_One_Callback_With_Data for details.',

	'6495',	'New settings for the \ref Set_Rendering_Options_display_lists "display lists" rendering option allow better control over the batching of geometry that is added to the display lists.',

	'6592',	'Selection events can now be asked to return the containing segment or containing segment tree of an item that was selected. See the new \ref Set_Heuristics_selection_level "selection level" heuristic option for details.',

	'6600',	'It is now possible to generate images from an OpenGL-rendered scene on any hardware that supports the OpenGL \'GL_ARB_pixel_buffer_object\' extension.  This can be particularly applicable on many Linux and possibly some Solaris systems.',

	'6711',	'Enhancements to the tristripping code reduces tristrip creation time by splitting up large shells into spatially coherent subparts before handing them off to the tristripper.',

	'6743',	'A new rendering option allows the user to tell HOOPS/3dGS to draw a reflection of the model on a given plane. See the \ref Set_Rendering_Options_simple_reflection "simple reflection" rendering option for details.',

#	'6819',	'',

	'6894',	'When using the CGM3 driver, the user can explicitly set the font table that is written into the output file. When used in conjunction with ::HIC_Set_Text_Font_Index, this allows the user to reference fonts installed on the system, so that a viewer application can use system fonts when displaying the CGM3 file.',

	'6896',	'Polyline routines have been enhanced to support disjointed polylines. By using a negative value for the <em>count</em> parameter, polylines can be made to appear as a series of 2-point line segments. This gives the user a method by which to insert a collection of line segments into the scene graph.',

	'6924',	'This release introduces a new type of surface that can be created by sweeping a given shell along a path. sFor details, see the documentation for ::Compute_Swept_Shell and its variants.',

	'6982',	'The default behavior of text bounding boxes has changed. To ensure that text bounding boxes extend beyond the width of a given text string, HOOPS/3dGS now adds the width of the letter \'X\' to the bounding box before it is returned to the user. To revert to the pre-16.0 text bounding box behavior, users must set a new system option \ref Define_System_Options_legacy_text_extent "legacy text extent".',

	'7005',	'It is no longer painful to get the name of an image from an image key. Users may now query the name directly by calling ::Show_Image_Name. ',

	'7014',	'Users can speed up the calculation of model info for large models using the new function ::Show_Shell_Tristrip_Count. This interface allows users to query the number of tristrips that 3dGS creates for a specific shell.',

	'7185',	'The 16.0 release presents enhanced support for simple reflection planes. Users may now control the blurring and attenuation of model reflections, by using two new sub-options for the \ref Set_Rendering_Options_simple_reflection "\'simple reflection\' rendering option".',

	'7186',	'A new shadow mapping option -- \ref Set_Rendering_Options "jitter" -- has been added to reduce aliasing in shadow maps. Please note that the shadow map option is only supported in our DirectX driver.',

	'7314',	'::Show_Geometry_Pointer references point data that is stored within the HOOPS database. This function is useful because it allows for access (read-only) without incurring the performance and memory costs of creating a new copy. In this release, we have enhanced the functionality of this interface by adding support for raster data. In practice, this means that users can now quickly query the raster data that is associated with an image.',

	'7349',	'HOOPS/3dGS now supports multiple instances of the Printf HDI driver.',

	'7835',	'It is now possible to force HOOPS to trigger a full update when only an incremental update is required, so that HOOPS resets the camera near limit. See the new system option \ref Define_System_Options_near_limit_update_promotion "near limit update promotion" for details.',

);

open (FH, ">ReleaseNotes_C.pre");

print FH <<EOF;
/*! \\page ReleaseNotes_C 
<H2 align="left"><B><A href="#FC0">1.0 Functional Changes</A></B></H2>
<OL>
  <H3>
    <A href="#FC2">Routines Deprecated</A><BR>
    <A href="#FC3">Options Deprecated</A><BR>
    <A href="#FC4">Drivers Dropped</A><BR>
    <A href="#FC5">Build and Linkage Changes</A><BR>
    <A href="#FC6">Interface Changes</A><BR>
    <A href="#FC7">Behavioral Changes</A><BR>
  </H3>
</OL>


<H2 align="left"><B> <A href="#F0">2.0 New Features and Enhancements</A></B></H2>
<OL>
<H3>
EOF
########## ----html---- ###########


my $issue_number;

foreach $issue_number (sort keys (%features))
{
	print FH "<A href=\"\#$issue_number\">$issue_number - $features{$issue_number}</A><br>\n";
}


########## ----html---- ###########
print FH <<EOF;
</H3>
</OL>

<HR>

<!------Detailed Changes------------->
<A name=FC0></A> <H2>1.0 Functional Changes</H2>

<H5>This list includes changes to the HOOPS/3dGS API and driver interface since version 15.0. These changes could affect the performance of HOOPS-based applications. </H5>

<H3><A name=FC2>Deprecated Routines</A></H3>
  <H5>None</H5>

<H3><A name=FC3>Deprecated Options</A></H3>
  <H5>None</H5>
<!--
<ul>
<p><li><b>OPTION 1</b>
<p>OPTION 1 DESCRIPTION.
</ul>
-->

<H3><A name=FC4>Dropped Drivers</A></H3>
  <H5>None</H5>

<H3><A name=FC5>Build and Linkage Changes</A></H3>
<ul>
<p><li><b>Debug Bin Directory</b>
<p>See the <a href="../Introduction/AfCReleaseNotes_C.html#Functional_Changes">HOOPS/3dAF Release Notes</a> for details.
</ul>

<H3><A name=FC6>Interface Changes</A></H4>
  <H5>None</H5>

<H3><A name=FC7>Behavioral Changes</A></H4>
<ul>
<p><li><b>Text Bounding Boxes</b>
<p>See the <a class="elRef" doxygen="hoops_3dgs_hc.tag:../Hoops3DGS/hc_ref_manual/" href="../Hoops3DGS/hc_ref_manual/group___define___system___options.html#Define_System_Options_legacy_text_extent">legacy text extent</a> system option for details.
</ul>

  
<DIV align="right"> 
  <H6 align="left"><IMG height="14" src="../images/Earth.gif"
   width="14" align="bottom" nosave>Return to<B>
   <A href="#top">Index</A></B>
  </H6>
</DIV>

<CENTER>
  <HR>
</CENTER>

<!------New Features and Enhancements------------->
<H2 align="left"><A name="F0"></A>2.0 New Features and Enhancements</H2>
<ul>
EOF
########## ----html---- ###########


foreach $issue_number (sort keys (%features))
{
	print FH "<li><H3 align=\"left\"><A name=\"$issue_number\">$features{$issue_number}</A></H3>\n";
	print FH "<p>$details{$issue_number}\n\n";
}

########## ----html---- ###########
print FH <<EOF;
</ul>
<DIV align="right"> 
  <H6 align="left"><IMG height="14" src="../images/Earth.gif"
   width="14" align="bottom" nosave>Return to<B>
   <A href="#top">Index</A></B>
  </H6>
</DIV>

<CENTER>
  <HR>
</CENTER>


*/
EOF
########## ----html---- ###########

close (FH);
system "doxygen config_relnotes.dox";

exit;




